<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (118)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
  </head>
  <body>
    <h1 id="forms-event-and-method-submit">Forms: event and method submit</h1>
    <p>
      The <code>submit</code> event triggers when the form is submitted, it is
      usually used to validate the form before sending it to the server or to
      abort the submission and process it in JavaScript.
    </p>
    <p>
      The method <code>form.submit()</code> allows to initiate form sending from
      JavaScript. We can use it to dynamically create and send our own forms to
      server.
    </p>
    <p>Let’s see more details of them.</p>
    <h2 id="event-submit">Event: submit</h2>
    <p>There are two main ways to submit a form:</p>
    <ol type="1">
      <li>
        The first – to click <code>&lt;input type="submit"&gt;</code> or
        <code>&lt;input type="image"&gt;</code>.
      </li>
      <li>The second – press <code>key:Enter</code> on an input field.</li>
    </ol>
    <p>
      Both actions lead to <code>submit</code> event on the form. The handler
      can check the data, and if there are errors, show them and call
      <code>event.preventDefault()</code>, then the form won’t be sent to the
      server.
    </p>
    <p>In the form below:</p>
    <ol type="1">
      <li>Go into the text field and press <code>key:Enter</code>.</li>
      <li>Click <code>&lt;input type="submit"&gt;</code>.</li>
    </ol>
    <p>
      Both actions show <code>alert</code> and the form is not sent anywhere due
      to <code>return false</code>:
    </p>
    <p>
      <code
        >html autorun height=60 no-beautify &lt;form
        onsubmit="alert('submit!');return false"&gt; First: Enter in the input
        field &lt;input type="text" value="text" /&gt;&lt;br /&gt; Second: Click
        "submit": &lt;input type="submit" value="Submit" /&gt;
        &lt;/form&gt;</code
      >
    </p>
    <p>
      ```<code>smart header="Relation between</code
      >submit<code>and</code>click<code>" When a form is sent using</code
      >key:Enter<code>on an input field, a</code>click<code
        >event triggers on the</code
      ><input type="submit" />`.
    </p>
    <p>That’s rather funny, because there was no click at all.</p>
    <p>Here’s the demo:</p>
    <p>
      <code
        >html autorun height=60 &lt;form onsubmit="return false"&gt; &lt;input
        type="text" size="30" value="Focus here and press enter" /&gt; &lt;input
        type="submit" value="Submit" *!*onclick="alert('click')"*/!*&gt;
        &lt;/form&gt;</code
      >
    </p>
    <pre><code>
## Method: submit

To submit a form to the server manually, we can call `form.submit()`.

Then the `submit` event is not generated. It is assumed that if the programmer calls `form.submit()`, then the script already did all related processing.

Sometimes that&#39;s used to manually create and send a form, like this:

```js run
let form = document.createElement(&#39;form&#39;);
form.action = &#39;https://google.com/search&#39;;
form.method = &#39;GET&#39;;

form.innerHTML = &#39;&lt;input name=&quot;q&quot; value=&quot;test&quot;&gt;&#39;;

// the form must be in the document to submit it
document.body.append(form);

form.submit();
```</code></pre>
  </body>
</html>
